<script setup lang="ts">
import { useRouter } from 'vue-router';
import { useUserStore } from '@new-jira-clone/libs/src/store';
import { AuthApiService, useInitSocket } from '@/shared/api';
import { type User } from '@/shared/api';
import { pathConfig } from '@/shared';
import GuestList from './GuestList.vue';

const router = useRouter();

const fetchGuests = async (): Promise<User[]> => {
  const guestList = await AuthApiService.guestsList();

  if (guestList.data) {
    return guestList.data;
  }

  return [];
};

const signIn = async (email: string): Promise<void> => {
  const { setUser } = useUserStore();
  const { initSocketConnect } = useInitSocket();

  const guestSignInResult = await AuthApiService.guestSignIn(email);

  if (guestSignInResult.status === 201) {
    setUser(guestSignInResult.data);
    initSocketConnect();
    router.push(pathConfig.default);
  }
};
</script>

<template>
  <GuestList
    :fetch-guest="fetchGuests"
    :guest-sign-in="signIn"
  />
</template>
